--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/packet.c	Mon Nov 14 16:21:14 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/packet.c	Mon Nov 14 16:21:14 2016
@@ -21,6 +21,7 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #include <string.h>
@@ -413,16 +414,14 @@
     uint_t opt_len)
 {
 	uchar_t		*raw_pkt;
-	int		req_len;
+	size_t		req_len;
 	void		*optr;
 
 	raw_pkt = (uchar_t *)dpkt->pkt;
 	optr = raw_pkt + dpkt->pkt_cur_len;
 	if (dpkt->pkt_isv6) {
-		dhcpv6_option_t d6o;
+		req_len = opt_len + sizeof (dhcpv6_option_t);
 
-		req_len = opt_len + sizeof (d6o);
-
 		if (dpkt->pkt_cur_len + req_len > dpkt->pkt_max_len) {
 			dhcpmsg(MSG_WARNING,
 			    "add_pkt_opt: not enough room for v6 option %u in "
@@ -430,17 +429,8 @@
 			    dpkt->pkt_cur_len, req_len, dpkt->pkt_max_len);
 			return (NULL);
 		}
-		d6o.d6o_code = htons(opt_type);
-		d6o.d6o_len = htons(opt_len);
-		(void) memcpy(&raw_pkt[dpkt->pkt_cur_len], &d6o, sizeof (d6o));
-		dpkt->pkt_cur_len += sizeof (d6o);
-		if (opt_len > 0) {
-			(void) memcpy(&raw_pkt[dpkt->pkt_cur_len], opt_val,
-			    opt_len);
-			dpkt->pkt_cur_len += opt_len;
-		}
 	} else {
-		req_len = opt_len + 2; /* + 2 for code & length bytes */
+		req_len = opt_len + DHCP_OPT_META_LEN;
 
 		/* CD_END and CD_PAD options don't have a length field */
 		if (opt_type == CD_END || opt_type == CD_PAD) {
@@ -457,19 +447,62 @@
 			    "packet", opt_type);
 			return (NULL);
 		}
+	}
 
-		raw_pkt[dpkt->pkt_cur_len++] = opt_type;
+	req_len = encode_dhcp_opt(&raw_pkt[dpkt->pkt_cur_len], dpkt->pkt_isv6,
+	    opt_type, opt_val, opt_len);
+	dpkt->pkt_cur_len += req_len;
 
-		if (req_len > 1) {
-			raw_pkt[dpkt->pkt_cur_len++] = opt_len;
-			if (opt_len > 0) {
-				(void) memcpy(&raw_pkt[dpkt->pkt_cur_len],
-				    opt_val, opt_len);
-				dpkt->pkt_cur_len += opt_len;
-			}
+	return (optr);
+}
+
+/*
+ * encode_dhcp_opt(): sets the fields of an allocated DHCP option buffer
+ *
+ *   input: void *: the buffer allocated for enough space for
+ *			(DHCPv6) dhcpv6_option_t and value, or for (DHCPv4) opt_type +
+ *			length + value (length/value are skipped for CD_END or
+ *			CD_PAD);
+ *	    boolean_t: a value indicating whether DHCPv6 or not;
+ *	    uint_t: the type of option being added;
+ *	    const void *: the value of that option;
+ *	    uint_t: the length of the value of the option
+ *  output: size_t: the number of bytes written starting at opt.
+ */
+
+size_t
+encode_dhcp_opt(void *dopt, boolean_t isv6, uint_t opt_type,
+    const void *opt_val, uint_t opt_len)
+{
+	boolean_t do_copy_value = B_FALSE;
+	size_t res_len = 0;
+	uint8_t *pval;
+
+	if (isv6) {
+		dhcpv6_option_t d6o;
+		d6o.d6o_code = htons(opt_type);
+		d6o.d6o_len = htons(opt_len);
+		(void) memcpy(dopt, &d6o, sizeof (d6o));
+		res_len += sizeof (d6o);
+
+		do_copy_value = B_TRUE;
+	} else {
+		pval = (uint8_t *)dopt;
+		pval[res_len++] = opt_type;
+
+		if (opt_type != CD_END && opt_type != CD_PAD) {
+			pval[res_len++] = opt_len;
+			do_copy_value = B_TRUE;
 		}
 	}
-	return (optr);
+
+	pval = (uint8_t *)dopt + res_len;
+	if (do_copy_value && opt_len > 0) {
+		(void) memcpy(pval, opt_val, opt_len);
+		res_len += opt_len;
+	}
+
+	return (res_len);
 }
 
 /*
--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/packet.h	Mon Nov 14 16:21:14 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/packet.h	Mon Nov 14 16:21:14 2016
@@ -21,6 +21,7 @@
 /*
  * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #ifndef	_PACKET_H
@@ -122,6 +123,8 @@
 boolean_t	remove_pkt_opt(dhcp_pkt_t *, uint_t);
 boolean_t	update_v6opt_len(dhcpv6_option_t *, int);
 void		*add_pkt_opt(dhcp_pkt_t *, uint_t, const void *, uint_t);
+size_t		encode_dhcp_opt(void *, boolean_t, uint_t, const void *,
+			uint_t);
 void		*add_pkt_subopt(dhcp_pkt_t *, dhcpv6_option_t *, uint_t,
 		    const void *, uint_t);
 void		*add_pkt_opt16(dhcp_pkt_t *, uint_t, uint16_t);
--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/renew.c	Mon Nov 14 16:21:14 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/renew.c	Mon Nov 14 16:21:14 2016
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 1999, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #include <sys/types.h>
@@ -462,6 +463,9 @@
 		/* Add required Option Request option */
 		(void) add_pkt_prl(dpkt, dsmp);
 
+		/* Add FQDN if configured */
+		(void) dhcp_add_fqdn_opt(dpkt, dsmp);
+
 		return (send_pkt_v6(dsmp, dpkt, dsmp->dsm_server,
 		    stop_extending, irt, mrt));
 	} else {
@@ -490,7 +494,8 @@
 		 * dhcp_selecting() if the REQUEST_HOSTNAME option was set and
 		 * a host name was found.
 		 */
-		if (dsmp->dsm_reqhost != NULL) {
+		if (dhcp_add_fqdn_opt(dpkt, dsmp) != 0 &&
+		    dsmp->dsm_reqhost != NULL) {
 			(void) add_pkt_opt(dpkt, CD_HOSTNAME, dsmp->dsm_reqhost,
 			    strlen(dsmp->dsm_reqhost));
 		}
--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/request.c	Mon Nov 14 16:21:14 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/request.c	Mon Nov 14 16:21:14 2016
@@ -21,6 +21,7 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  *
  * REQUESTING state of the client state machine.
  */
@@ -79,6 +80,9 @@
 	/* Add required Option Request option */
 	(void) add_pkt_prl(dpkt, dsmp);
 
+	/* Add FQDN if configured */
+	(void) dhcp_add_fqdn_opt(dpkt, dsmp);
+
 	(void) send_pkt_v6(dsmp, dpkt, dsmp->dsm_server, stop_requesting,
 	    DHCPV6_REQ_TIMEOUT, DHCPV6_REQ_MAX_RT);
 
@@ -313,7 +317,8 @@
 		 * dhcp_selecting() if the DF_REQUEST_HOSTNAME option set and a
 		 * host name was found
 		 */
-		if (dsmp->dsm_reqhost != NULL) {
+		if (dhcp_add_fqdn_opt(dpkt, dsmp) != 0 &&
+		    dsmp->dsm_reqhost != NULL) {
 			(void) add_pkt_opt(dpkt, CD_HOSTNAME, dsmp->dsm_reqhost,
 			    strlen(dsmp->dsm_reqhost));
 		}
--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/select.c	Mon Nov 14 16:21:14 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/select.c	Mon Nov 14 16:21:14 2016
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 1999, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  *
  * SELECTING state of the client state machine.
  */
@@ -29,7 +30,6 @@
 #include <stdlib.h>
 #include <strings.h>
 #include <time.h>
-#include <limits.h>
 #include <netinet/in.h>
 #include <net/route.h>
 #include <net/if.h>
@@ -106,8 +106,6 @@
 dhcp_selecting(dhcp_smach_t *dsmp)
 {
 	dhcp_pkt_t		*dpkt;
-	const char		*reqhost;
-	char			hostfile[PATH_MAX + 1];
 
 	/*
 	 * We first set up to collect OFFER/Advertise packets as they arrive.
@@ -178,6 +176,9 @@
 
 		/* xxx add Reconfigure Accept */
 
+		/* Add FQDN if configured */
+		(void) dhcp_add_fqdn_opt(dpkt, dsmp);
+
 		(void) send_pkt_v6(dsmp, dpkt, ipv6_all_dhcp_relay_and_servers,
 		    stop_selecting, DHCPV6_SOL_TIMEOUT, DHCPV6_SOL_MAX_RT);
 	} else {
@@ -201,27 +202,9 @@
 		}
 		(void) add_pkt_prl(dpkt, dsmp);
 
-		if (df_get_bool(dsmp->dsm_name, dsmp->dsm_isv6,
-		    DF_REQUEST_HOSTNAME)) {
-			dhcpmsg(MSG_DEBUG,
-			    "dhcp_selecting: DF_REQUEST_HOSTNAME");
-			(void) snprintf(hostfile, sizeof (hostfile),
-			    "/etc/hostname.%s", dsmp->dsm_name);
+		if (dhcp_add_fqdn_opt(dpkt, dsmp) != 0)
+			(void) dhcp_add_hostname_opt(dpkt, dsmp);
 
-			if ((reqhost = iffile_to_hostname(hostfile)) != NULL) {
-				dhcpmsg(MSG_DEBUG, "dhcp_selecting: host %s",
-				    reqhost);
-				dsmp->dsm_reqhost = strdup(reqhost);
-				if (dsmp->dsm_reqhost != NULL)
-					(void) add_pkt_opt(dpkt, CD_HOSTNAME,
-					    dsmp->dsm_reqhost,
-					    strlen(dsmp->dsm_reqhost));
-				else
-					dhcpmsg(MSG_WARNING,
-					    "dhcp_selecting: cannot allocate "
-					    "memory for host name option");
-			}
-		}
 		(void) add_pkt_opt(dpkt, CD_END, NULL, 0);
 
 		(void) send_pkt(dsmp, dpkt, htonl(INADDR_BROADCAST),
--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/states.c	Mon Nov 14 16:21:14 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/states.c	Mon Nov 14 16:21:14 2016
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 1999, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  *
  * This module contains core functions for managing DHCP state machine
  * instances.
@@ -332,6 +333,8 @@
 	free(dsmp->dsm_pil);
 	free(dsmp->dsm_routers);
 	free(dsmp->dsm_reqhost);
+	free(dsmp->dsm_msg_reqhost);
+	free(dsmp->dsm_reqfqdn);
 	free(dsmp);
 
 	/* no big deal if this fails */
@@ -1049,7 +1052,8 @@
 	 * unable to parse it.  We need to determine if a Client ID is required
 	 * and, if so, generate one.
 	 *
-	 * If it's IPv4, not in an IPMP group, and not a logical interface,
+	 * If it's IPv4, not in an IPMP group, not a logical interface,
+	 * and a DHCP default for DF_V4_DEFAULT_IAID_DUID is not affirmative,
 	 * then we need to preserve backward-compatibility by avoiding
 	 * new-fangled DUID/IAID construction.  (Note: even for IPMP test
 	 * addresses, we construct a DUID/IAID since we may renew a lease for
@@ -1056,7 +1060,9 @@
 	 * an IPMP test address on any functioning IP interface in the group.)
 	 */
 	if (!pif->pif_isv6 && pif->pif_grifname[0] == '\0' &&
-	    strchr(dsmp->dsm_name, ':') == NULL) {
+	    strchr(dsmp->dsm_name, ':') == NULL &&
+	    !df_get_bool(dsmp->dsm_name, pif->pif_isv6,
+	    DF_V4_DEFAULT_IAID_DUID)) {
 		if (pif->pif_hwtype == ARPHRD_IB) {
 			/*
 			 * This comes from the DHCP over IPoIB specification.
@@ -1218,6 +1224,15 @@
 	free(dsmp->dsm_reqhost);
 	dsmp->dsm_reqhost = NULL;
 
+	/*
+	 * Do not reset dsm_msg_reqhost here. Unlike dsm_reqhost coming from
+	 * /etc/host.*, dsm_msg_reqhost comes externally, and it survives until
+	 * it is reset from another external message.
+	 */
+
+	free(dsmp->dsm_reqfqdn);
+	dsmp->dsm_reqfqdn = NULL;
+
 	cancel_smach_timers(dsmp);
 
 	(void) set_smach_state(dsmp, INIT);
--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/states.h	Mon Nov 14 16:21:15 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/states.h	Mon Nov 14 16:21:15 2016
@@ -21,6 +21,7 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #ifndef	STATES_H
@@ -201,6 +202,19 @@
 	char		*dsm_reqhost;
 
 	/*
+	 * The host name we've been asked by IPC message (e.g.,
+	 * `ipadm -T dhcp -h ...') to request is remembered here until it is
+	 * reset by another external message.
+	 */
+	char		*dsm_msg_reqhost;
+
+	/*
+	 * The determined FQDN is remembered here between the DISCOVER/SOLICIT
+	 * and the REQUEST.
+	 */
+	char		*dsm_reqfqdn;
+
+	/*
 	 * V4 and V6 use slightly different timers.  For v4, we must count
 	 * seconds from the point where we first try to configure the
 	 * interface.  For v6, only seconds while performing a transaction
--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/util.c	Mon Nov 14 16:21:15 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/util.c	Mon Nov 14 16:21:15 2016
@@ -20,11 +20,13 @@
  */
 /*
  * Copyright (c) 1999, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #include <unistd.h>
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <sys/utsname.h>
 #include <stdlib.h>
 #include <netinet/in.h>		/* struct in_addr */
 #include <netinet/dhcp.h>
@@ -35,10 +37,16 @@
 #include <string.h>
 #include <dhcpmsg.h>
 #include <ctype.h>
+#include <arpa/inet.h>
+#include <arpa/nameser.h>
+#include <resolv.h>
 #include <netdb.h>
 #include <fcntl.h>
 #include <stdio.h>
 #include <dhcp_hostconf.h>
+#include <limits.h>
+#include <strings.h>
+#include <libipadm.h>
 
 #include "states.h"
 #include "agent.h"
@@ -45,6 +53,7 @@
 #include "interface.h"
 #include "util.h"
 #include "packet.h"
+#include "defaults.h"
 
 /*
  * this file contains utility functions that have no real better home
@@ -67,6 +76,12 @@
  *  o  true miscellany -- anything else
  */
 
+#define	ETCNODENAME		"/etc/nodename"
+#define	ETCDEFAULTDOMAIN	"/etc/defaultdomain"
+
+static	boolean_t	is_fqdn(const char *);
+static int			dhcp_assemble_fqdn(dhcp_smach_t *dsmp);
+
 /*
  * pkt_type_to_string(): stringifies a packet type
  *
@@ -466,35 +481,6 @@
 }
 
 /*
- * valid_hostname(): check whether a string is a valid hostname
- *
- *   input: const char *: the string to verify as a hostname
- *  output: boolean_t: B_TRUE if the string is a valid hostname
- *
- * Note that we accept both host names beginning with a digit and
- * those containing hyphens.  Neither is strictly legal according
- * to the RFCs, but both are in common practice, so we endeavour
- * to not break what customers are using.
- */
-
-static boolean_t
-valid_hostname(const char *hostname)
-{
-	unsigned int i;
-
-	for (i = 0; hostname[i] != '\0'; i++) {
-
-		if (isalpha(hostname[i]) || isdigit(hostname[i]) ||
-		    (((hostname[i] == '-') || (hostname[i] == '.')) && (i > 0)))
-			continue;
-
-		return (B_FALSE);
-	}
-
-	return (i > 0);
-}
-
-/*
  * iffile_to_hostname(): return the hostname contained on a line of the form
  *
  * [ ^I]*inet[ ^I]+hostname[\n]*\0
@@ -556,7 +542,7 @@
 					    " host name too long");
 					return (NULL);
 				}
-				if (valid_hostname(p)) {
+				if (ipadm_is_valid_hostname(p)) {
 					return (p);
 				} else {
 					dhcpmsg(MSG_WARNING,
@@ -704,4 +690,416 @@
 		dhcpmsg(MSG_ERR, "cannot write %s (reboot will "
 		    "not use cached configuration)", hcfile);
 	}
+}
+
+/*
+ * Try to get a string from the first line of a file, up to but not
+ * including any space (0x20) or newline.
+ */
+
+static int
+dhcp_get_oneline(const char *filename, char *buf, size_t buflen)
+{
+	char	value[SYS_NMLN], *c;
+	int		fd, i;
+
+	if ((fd = open(filename, O_RDONLY)) <= 0) {
+		dhcpmsg(MSG_DEBUG, "dhcp_get_oneline: could not open %s",
+		    filename);
+		*buf = '\0';
+	} else {
+		if ((i = read(fd, value, SYS_NMLN - 1)) <= 0) {
+			dhcpmsg(MSG_WARNING, "dhcp_get_oneline: no line in %s",
+			    filename);
+			*buf = '\0';
+		} else {
+			value[i] = '\0';
+			if ((c = strchr(value, '\n')) != NULL)
+				*c = '\0';
+			if ((c = strchr(value, ' ')) != NULL)
+				*c = '\0';
+
+			if (strlcpy(buf, value, buflen) >= buflen) {
+				dhcpmsg(MSG_WARNING, "dhcp_get_oneline: too long value, %s",
+				    value);
+				*buf = '\0';
+			}
+		}
+		(void) close(fd);
+	}
+
+	return (*buf != '\0' ? 0 : -1);
+}
+
+/*
+ * Try to get the hostname from the /etc/nodename file. uname(2) cannot
+ * be used, because that is initialized after DHCP has solicited, in order
+ * to allow for the possibility that utsname.nodename can be set from
+ * DHCP Hostname. Here, though, we want to send a value specified
+ * advance of DHCP, so read /etc/nodename directly.
+ */
+
+static int
+dhcp_get_nodename(char *buf, size_t buflen)
+{
+	return dhcp_get_oneline(ETCNODENAME, buf, buflen);
+}
+
+/*
+ * Try to get the value from the /etc/defaultdomain file. libnsl's
+ * domainname() cannot be used, because that is initialized after DHCP has
+ * solicited. Here, though, we want to send a value specified in advance
+ * of DHCP, so read /etc/defaultdomain directly.
+ */
+
+static int
+dhcp_get_defaultdomain(char *buf, size_t buflen)
+{
+	return dhcp_get_oneline(ETCDEFAULTDOMAIN, buf, buflen);
+}
+
+/*
+ * dhcp_add_hostname_opt(): Set CD_HOSTNAME option if REQUEST_HOSTNAME is
+ *			 affirmative and if 1) dsm_msg_reqhost is available; or
+ *			 2) hostname is read from an extant /etc/hostname.<ifname>
+ *			 file; or 3) interface is primary and nodename(4) is defined.
+ *
+ *   input: dhcp_pkt_t *: pointer to DHCP message being constructed;
+ *	    dhcp_smach_t *: pointer to interface DHCP state machine;
+ */
+
+int
+dhcp_add_hostname_opt(dhcp_pkt_t *dpkt, dhcp_smach_t *dsmp)
+{
+	const char	*reqhost;
+	char	nodename[MAXNAMELEN];
+
+	if (!df_get_bool(dsmp->dsm_name, dsmp->dsm_isv6, DF_REQUEST_HOSTNAME))
+		return (0);
+
+	dhcpmsg(MSG_DEBUG, "dhcp_add_hostname_opt: DF_REQUEST_HOSTNAME");
+
+	if (dsmp->dsm_msg_reqhost != NULL
+	    && ipadm_is_valid_hostname(dsmp->dsm_msg_reqhost)) {
+		reqhost = dsmp->dsm_msg_reqhost;
+	} else {
+		char		hostfile[PATH_MAX + 1];
+
+		(void) snprintf(hostfile, sizeof (hostfile),
+		    "/etc/hostname.%s", dsmp->dsm_name);
+		reqhost = iffile_to_hostname(hostfile);
+	}
+
+	if (reqhost == NULL && (dsmp->dsm_dflags & DHCP_IF_PRIMARY) &&
+	    dhcp_get_nodename(nodename, sizeof (nodename)) == 0) {
+		reqhost = nodename;
+	}
+
+	if (reqhost != NULL) {
+		free(dsmp->dsm_reqhost);
+		if ((dsmp->dsm_reqhost = strdup(reqhost)) == NULL)
+			dhcpmsg(MSG_WARNING, "dhcp_add_hostname_opt: cannot allocate "
+			    "memory for host name option");
+	}
+
+	if (dsmp->dsm_reqhost != NULL) {
+		dhcpmsg(MSG_DEBUG, "dhcp_add_hostname_opt: host %s for %s",
+		    dsmp->dsm_reqhost, dsmp->dsm_name);
+		(void) add_pkt_opt(dpkt, CD_HOSTNAME, dsmp->dsm_reqhost,
+		    strlen(dsmp->dsm_reqhost));
+		return 1;
+	}
+	else {
+		dhcpmsg(MSG_DEBUG, "dhcp_add_hostname_opt: no hostname for %s",
+		    dsmp->dsm_name);
+	}
+
+	return (0);
+}
+
+/*
+ * dhcp_add_fqdn_opt(): Set CD_CLIENTFQDN option if dsm_reqfqdn is not NULL
+ *			 or if dhcp_assemble_fqdn() initializes it. If dsm_reqfqdn
+ *			 cannot be set, no option will be added.
+ *
+ *   input: dhcp_pkt_t *: pointer to DHCP message being constructed;
+ *	    dhcp_smach_t *: pointer to interface DHCP state machine;
+ *  output: 0 if a CLIENT_FQDN was added; non-zero if otherwise;
+ */
+
+int
+dhcp_add_fqdn_opt(dhcp_pkt_t *dpkt, dhcp_smach_t *dsmp)
+{
+	/*
+	 * RFC 4702 section 2:
+	 *
+	 * The format of the Client FQDN option is:
+	 *
+	 *  Code   Len    Flags  RCODE1 RCODE2   Domain Name
+	 * +------+------+------+------+------+------+--
+	 * |  81  |   n  |      |      |      |       ...
+	 * +------+------+------+------+------+------+--
+	 *
+	 * Code and Len are distinct, and the remainder is in a single buffer,
+	 * opt81, for Flags + (unused) RCODE1 and RCODE2 (all octets) and a
+	 * potentially maximum-length domain name.
+	 *
+	 * The format of the Flags field is:
+	 *
+	 *  0 1 2 3 4 5 6 7
+	 * +-+-+-+-+-+-+-+-+
+	 * |  MBZ  |N|E|O|S|
+	 * +-+-+-+-+-+-+-+-+
+	 *
+	 * where MBZ is ignored and NEOS are:
+	 *
+	 * S = 1 to request that "the server SHOULD perform the A RR (FQDN-to-
+	 * address) DNS updates;
+	 *
+	 * O = 0, for a server-only response bit;
+	 *
+	 * E = 1 to indicate the domain name is in "canonical wire format,
+	 * without compression (i.e., ns_name_pton2) ....  This encoding SHOULD
+	 * be used by clients ....";
+	 *
+	 * N = 0 to request that "the server SHALL perform DNS updates [of the
+	 * PTR RR]." (1 would request SHALL NOT update).
+	 *
+	 * The format of the DHCPv6 Client FQDN option is shown below:
+	 *
+	 *     0                   1                   2                   3
+	 *     0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+	 *    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+	 *    |          OPTION_FQDN          |         option-len            |
+	 *    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+	 *    |   flags       |                                               |
+	 *    +-+-+-+-+-+-+-+-+                                               |
+	 *    .                                                               .
+	 *    .                          domain-name                          .
+	 *    .                                                               .
+	 *    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+	 *
+	 *      option-code      OPTION_CLIENT_FQDN (39)
+	 *
+	 *      option-len       1 + length of domain name
+	 *
+	 *      flags            flag bits used between client and server to
+	 *                       negotiate who performs which updates
+	 *
+	 *      domain-name      the partial or fully qualified domain name
+	 *                       (with length option-len - 1)
+	 *
+	 *    The DHCPv6 format of the Flags field is:
+	 *
+	 *         0 1 2 3 4 5 6 7
+	 *        +-+-+-+-+-+-+-+-+
+	 *        |  MBZ    |N|O|S|
+	 *        +-+-+-+-+-+-+-+-+
+	 */
+
+	const uint8_t	S_BITPOS = 7 - 7;
+	const uint8_t	E_BITPOS = 7 - 5;
+	const size_t	OPT_FQDN_METALEN = 3, OPT_V6_FQDN_METALEN = 1;
+	uint_t		fqdncode;
+	u_char		enc_fqdnbuf[MAXNAMELEN];
+	uint8_t		fqdnopt[MAXNAMELEN + OPT_FQDN_METALEN];
+	size_t		len, metalen;
+
+	if (dsmp->dsm_reqfqdn == NULL && dhcp_assemble_fqdn(dsmp) != 0)
+		return (-1);
+
+	/* encode the FQDN in canonical wire format */
+
+	if (ns_name_pton2(dsmp->dsm_reqfqdn, enc_fqdnbuf, sizeof (enc_fqdnbuf),
+	    &len) < 0) {
+		dhcpmsg(MSG_WARNING, "dhcp_add_fqdn_opt: error encoding domain"
+		    " name %s", dsmp->dsm_reqfqdn);
+		return (-1);
+	}
+
+	dhcpmsg(MSG_DEBUG, "dhcp_add_fqdn_opt: interface FQDN is %s"
+	    " for %s", dsmp->dsm_reqfqdn, dsmp->dsm_name);
+
+	bzero(fqdnopt, sizeof (fqdnopt));
+	if (dsmp->dsm_isv6) {
+		fqdncode = DHCPV6_OPT_CLIENT_FQDN;
+		metalen = OPT_V6_FQDN_METALEN;
+		*fqdnopt = (uint8_t)(1 << S_BITPOS);
+	} else {
+		fqdncode = CD_CLIENTFQDN;
+		metalen = OPT_FQDN_METALEN;
+		*fqdnopt = (uint8_t)((1 << S_BITPOS) | (1 << E_BITPOS));
+	}
+	(void) memcpy(fqdnopt + metalen, enc_fqdnbuf, len);
+	(void) add_pkt_opt(dpkt, fqdncode, fqdnopt, metalen + len);
+
+	return (0);
+}
+
+/*
+ * dhcp_assemble_fqdn(): Set dsm_reqfqdn if REQUEST_FQDN is set and
+ *			 either a host name was sent in the IPC message (e.g., from
+ *			 ipadm(1M) -h,--reqhost) or the interface is primary and a
+ *			 nodename(4) is defined. If the host name is not already fully
+ *			 qualified per is_fqdn(), then a value from
+ *			 dhcp_get_defaultdomain() or from resolv.conf(4)--if defined--
+ *			 is used to construct an FQDN.
+ *
+ *			 If no FQDN can be determined, dsm_reqfqdn will be NULL.
+ *
+ *   input: dhcp_smach_t *: pointer to interface DHCP state machine;
+ *  output: 0 if dsm_reqfqdn was assigned; non-zero if otherwise;
+ */
+
+static int
+dhcp_assemble_fqdn(dhcp_smach_t *dsmp)
+{
+	char		fqdnbuf[MAXNAMELEN], nodename[MAXNAMELEN], *reqhost;
+	size_t		pos, len;
+
+	if (dsmp->dsm_reqfqdn != NULL) {
+		free(dsmp->dsm_reqfqdn);
+		dsmp->dsm_reqfqdn = NULL;
+	}
+
+	if (!df_get_bool(dsmp->dsm_name, dsmp->dsm_isv6, DF_REQUEST_FQDN))
+		return (-1);
+
+	dhcpmsg(MSG_DEBUG, "dhcp_assemble_fqdn: DF_REQUEST_FQDN");
+
+	bzero(fqdnbuf, sizeof (fqdnbuf));
+
+	reqhost = dsmp->dsm_msg_reqhost;
+	if (ipadm_is_nil_hostname(reqhost) &&
+	    (dsmp->dsm_dflags & DHCP_IF_PRIMARY) &&
+	    dhcp_get_nodename(nodename, sizeof (nodename)) == 0) {
+		reqhost = nodename;
+	}
+
+	if (ipadm_is_nil_hostname(reqhost)) {
+		dhcpmsg(MSG_DEBUG,
+		    "dhcp_assemble_fqdn: no interface reqhost for %s",
+		    dsmp->dsm_name);
+		return (-1);
+	}
+
+	if ((pos = strlcpy(fqdnbuf, reqhost, sizeof (fqdnbuf))) >=
+	    sizeof (fqdnbuf)) {
+		dhcpmsg(MSG_WARNING, "dhcp_assemble_fqdn: too long reqhost %s"
+		    " for %s", reqhost, dsmp->dsm_name);
+		return (-1);
+	}
+
+	if (!is_fqdn(reqhost)) {
+		char		dnamebuf[MAXHOSTNAMELEN];
+		size_t		needdots;
+		int			lasterrno;
+		char		*domainname = NULL;
+
+		/*
+		 * determine FQDN domain name, if possible
+		 */
+
+		if (dhcp_get_defaultdomain(dnamebuf, sizeof (dnamebuf)) == 0 &&
+		    !ipadm_is_nil_hostname(dnamebuf)) {
+			domainname = dnamebuf;
+		} else {
+			/*
+			 * fall back to resolv's "default domain (deprecated)"
+			 */
+
+			struct __res_state	res_state;
+			bzero(&res_state, sizeof (struct __res_state));
+
+			/* initialize resolver or warn */
+			if ((lasterrno = res_ninit(&res_state)) != 0) {
+				dhcpmsg(MSG_WARNING, "dhcp_assemble_fqdn: error %d"
+				    " initializing resolver", lasterrno);
+			}
+			else {
+				if (*res_state.defdname != '\0') {
+					(void) strlcpy(dnamebuf, res_state.defdname,
+					    sizeof (dnamebuf));
+					domainname = dnamebuf;
+				}
+				res_ndestroy(&res_state);
+			}
+		}
+
+		if (ipadm_is_nil_hostname(domainname)) {
+			dhcpmsg(MSG_DEBUG, "dhcp_assemble_fqdn: no domain name for %s",
+			    dsmp->dsm_name);
+			return (-1);
+		}
+
+		/*
+		 * Finish constructing FQDN. Account for space needed to hold a
+		 * separator '.' and a terminating '.'.
+		 */
+		len = strlen(domainname);
+		needdots = 1 + (domainname[len - 1] != '.');
+
+		if (pos + len + needdots >= sizeof (fqdnbuf)) {
+			dhcpmsg(MSG_WARNING, "dhcp_assemble_fqdn: too long FQDN %s.%s"
+			    " for %s", fqdnbuf, domainname, dsmp->dsm_name);
+			return (-1);
+		}
+
+		/* add separator and then domain name */
+		fqdnbuf[pos++] = '.';
+		(void) strlcpy(fqdnbuf + pos, domainname, sizeof (fqdnbuf) - pos);
+		pos += len;
+
+		/* ensure the final character is '.' */
+		if (needdots > 1)
+			fqdnbuf[pos++] = '.'; /* following is already zeroed */
+	}
+
+	if (!ipadm_is_valid_hostname(fqdnbuf)) {
+		dhcpmsg(MSG_WARNING, "dhcp_assemble_fqdn: invalid FQDN %s for %s",
+		    fqdnbuf, dsmp->dsm_name);
+		return (-1);
+	}
+
+	free(dsmp->dsm_reqfqdn);
+	if ((dsmp->dsm_reqfqdn = strdup(fqdnbuf)) == NULL) {
+		dhcpmsg(MSG_WARNING, "dhcp_assemble_fqdn: cannot allocate memory");
+		return (-1);
+	}
+	return (0);
+}
+
+/*
+ * is_fqdn() : Determine if the `hostname' can be considered as a Fully
+ *			Qualified Domain Name by being "rooted" (i.e., ending in '.')
+ *			or by containing at least three DNS labels (e.g.,
+ *			srv.example.com).
+ *
+ *   input: const char *: the hostname to inspect;
+ *  output: boolean_t: B_TRUE if `hostname' is not NULL satisfies the
+ *			criteria above; otherwise, B_FALSE;
+ */
+
+boolean_t
+is_fqdn(const char *hostname)
+{
+	const char *c;
+	size_t i;
+
+	if (hostname == NULL)
+		return (B_FALSE);
+
+	i = strlen(hostname);
+	if (i > 0 && hostname[i - 1] == '.')
+		return (B_TRUE);
+
+	c = hostname;
+	i = 0;
+	while ((c = strchr(c, '.')) != NULL) {
+		++i;
+		++c;
+	}
+
+	/* at least two separators is inferred to be fully-qualified */
+	return (i >= 2);
 }
--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/util.h	Mon Nov 14 16:21:15 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/util.h	Mon Nov 14 16:21:15 2016
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 1999, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #ifndef	UTIL_H
@@ -33,6 +34,7 @@
 #include <dhcpagent_ipc.h>
 
 #include "common.h"
+#include "packet.h"
 
 /*
  * general utility functions which have no better home.  see util.c
@@ -75,6 +77,8 @@
 int		dhcpv6_status_code(const dhcpv6_option_t *, uint_t,
     const char **, const char **, uint_t *);
 void		write_lease_to_hostconf(dhcp_smach_t *);
+int			dhcp_add_hostname_opt(dhcp_pkt_t *, dhcp_smach_t *);
+int			dhcp_add_fqdn_opt(dhcp_pkt_t *, dhcp_smach_t *);
 
 #ifdef	__cplusplus
 }
--- old/usr/src/cmd/cmd-inet/usr.sbin/ipadm/ipadm.c	Mon Nov 14 16:21:15 2016
+++ new/usr/src/cmd/cmd-inet/usr.sbin/ipadm/ipadm.c	Mon Nov 14 16:21:15 2016
@@ -21,6 +21,7 @@
 /*
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2012 Nexenta Systems, Inc. All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 #include <arpa/inet.h>
 #include <errno.h>
@@ -88,7 +89,8 @@
 	{ "create-addr", do_create_addr,
 	    "\tcreate-addr\t[-t] -T static [-d] "
 	    "-a{local|remote}=addr[/prefixlen]\n\t\t\t<addrobj>\n"
-	    "\tcreate-addr\t[-t] -T dhcp [-w <seconds> | forever] <addrobj>\n"
+	    "\tcreate-addr\t[-t] -T dhcp [-w <seconds> | forever]\n"
+	    "\t\t\t[-1] [-h <hostname>] <addrobj>\n"
 	    "\tcreate-addr\t[-t] -T addrconf [-i interface-id]\n"
 	    "\t\t\t[-p {stateful|stateless}={yes|no}] <addrobj>" },
 	{ "down-addr",	do_down_addr,	"\tdown-addr\t[-t] <addrobj>"	},
@@ -161,7 +163,9 @@
 	{"address",	required_argument,	0, 'a'	},
 	{"down",	no_argument,		0, 'd'	},
 	{"interface-id", required_argument,	0, 'i'	},
+	{"primary",	no_argument,		0, '1'	},
 	{"prop",	required_argument,	0, 'p'	},
+	{"reqhost", required_argument,	0, 'h'	},
 	{"temporary",	no_argument,		0, 't'	},
 	{"type",	required_argument,	0, 'T'	},
 	{"wait",	required_argument,	0, 'w'	},
@@ -632,8 +636,8 @@
 
 /*
  * Properties to be displayed is in `statep->sps_proplist'. If it is NULL,
- * for all the properties for the specified object, relavant information, will
- * be displayed. Otherwise, for the selected property set, display relevant
+ * for all the properties for the specified object, display relevant
+ * information. Otherwise, for the selected property set, display relevant
  * information
  */
 static void
@@ -1258,14 +1262,19 @@
 	char		*addrconf_arg = NULL;
 	char		*interface_id = NULL;
 	char		*wait = NULL;
+	char		*reqhost = NULL;
 	boolean_t	s_opt = _B_FALSE;	/* static addr options */
 	boolean_t	auto_opt = _B_FALSE;	/* Addrconf options */
 	boolean_t	dhcp_opt = _B_FALSE;	/* dhcp options */
+	boolean_t	primary_opt = _B_FALSE;	/* dhcp primary option */
 
 	opterr = 0;
-	while ((option = getopt_long(argc, argv, ":T:a:di:p:w:t",
+	while ((option = getopt_long(argc, argv, ":1T:a:dh:i:p:w:t",
 	    addr_longopts, NULL)) != -1) {
 		switch (option) {
+		case '1':
+			primary_opt = _B_TRUE;
+			break;
 		case 'T':
 			atype = optarg;
 			break;
@@ -1277,6 +1286,9 @@
 			flags &= ~IPADM_OPT_UP;
 			s_opt = _B_TRUE;
 			break;
+		case 'h':
+			reqhost = optarg;
+			break;
 		case 'i':
 			interface_id = optarg;
 			auto_opt = _B_TRUE;
@@ -1308,7 +1320,8 @@
 	 * Allocate and initialize the addrobj based on the address type.
 	 */
 	if (strcmp(atype, "static") == 0) {
-		if (static_arg == NULL || auto_opt || dhcp_opt) {
+		if (static_arg == NULL || auto_opt || dhcp_opt
+		    || reqhost != NULL || primary_opt) {
 			die("Invalid arguments for type %s\nusage: %s",
 			    atype, use);
 		}
@@ -1345,13 +1358,27 @@
 				    ipadm_status2str(status));
 			}
 		}
+		if (primary_opt) {
+			status = ipadm_set_primary(ipaddr, _B_TRUE);
+			if (status != IPADM_SUCCESS) {
+				die("Error in setting primary flag: %s",
+				    ipadm_status2str(status));
+			}
+		}
+		if (reqhost != NULL) {
+			status = ipadm_set_reqhost(ipaddr, reqhost);
+			if (status != IPADM_SUCCESS) {
+				die("Error in setting reqhost: %s",
+				    ipadm_status2str(status));
+			}
+		}
 	} else if (strcmp(atype, "addrconf") == 0) {
-		if (dhcp_opt || s_opt) {
+		if (dhcp_opt || s_opt || reqhost != NULL || primary_opt) {
 			die("Invalid arguments for type %s\nusage: %s",
 			    atype, use);
 		}
 
-		/* Initialize the addrobj for dhcp addresses. */
+		/* Initialize the addrobj for ipv6-addrconf addresses. */
 		status = ipadm_create_addrobj(IPADM_ADDR_IPV6_ADDRCONF,
 		    argv[optind], &ipaddr);
 		if (status != IPADM_SUCCESS) {
--- old/usr/src/cmd/cmd-inet/usr.sbin/nwamcfg/Makefile	Mon Nov 14 16:21:15 2016
+++ new/usr/src/cmd/cmd-inet/usr.sbin/nwamcfg/Makefile	Mon Nov 14 16:21:15 2016
@@ -22,6 +22,7 @@
 #
 # Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
 #
 # cmd/cmd-inet/usr.sbin/nwamcfg/Makefile
 
@@ -56,7 +57,7 @@
 nwamcfg_lex.c:	nwamcfg_lex.l nwamcfg_grammar.tab.h nwamcfg.h
 	$(LEX) $(LFLAGS) nwamcfg_lex.l > $@
 
-nwamcfg_grammar.tab.h nwamcfg_grammar.tab.c:	nwamcfg_grammar.y nwamcfg.h
+nwamcfg_grammar.tab.h + nwamcfg_grammar.tab.c:	nwamcfg_grammar.y nwamcfg.h
 	$(YACC) $(YFLAGS) nwamcfg_grammar.y
 
 nwamcfg_lex.o nwamcfg_grammar.tab.o := CCVERBOSE =
